/*
    File:       Flags.h

    Function:	

    Author:     Andrew Willmott

    Copyright:  (c) 1998-2000, Andrew Willmott
*/

#ifndef __Flags__
#define __Flags__

#include "cl/Basics.h"

class Flags32
{
public:
	Flags32() : bits(0) {};

	Void		Set(UInt32 flag)
				{ bits |= flag; };
	Void		UnSet(UInt32 flag)
				{ bits &= ~flag; };
	Bool		IsSet(UInt32 flag)			///< true if any of the flags are set
				{ return(bits & flag); };
	Bool		AreSet(UInt32 flags)		///< true if all flags are set
				{ return((bits & flags) == flags); };
	Void		Clear()
				{ bits = 0; };	

				operator UInt32()
				{ return(bits); };

protected:
	UInt32		bits;
};

class Flags16
{
public:
	Flags16() : bits(0) {};

	Void		Set(UInt16 flag)
				{ bits |= flag; };
	Void		UnSet(UInt16 flag)
				{ bits &= ~flag; };
	Bool		IsSet(UInt16 flag)
				{ return(bits & flag); };
	Bool		AreSet(UInt32 flags)
				{ return((bits & flags) == flags); };
	Void		Clear()
				{ bits = 0; };	

				operator UInt16()
				{ return(bits); };
	
protected:
	UInt16		bits;
};

class Flags8
{
public:
	Flags8() : bits(0) {};

	Void		Set(Byte flag)
				{ bits |= flag; };
	Void		UnSet(Byte flag)
				{ bits &= ~flag; };
	Bool		IsSet(Byte flag)
				{ return(bits & flag); };
	Bool		AreSet(UInt32 flags)
				{ return((bits & flags) == flags); };
	Void		Clear()
				{ bits = 0; };	

				operator Byte()
				{ return(bits); };
	
protected:
	Byte		bits;
};

#endif
